// Attempts to develop a pair class that is "universal" but
// illustrates the difficulties that arise.  Demonstrates the state of
// affairs before generics were introduced, that either a concrete
// type must be used or Object with casting must be used. Neither of
// these is particularly nice and using generics surmounts the
// problem.

class PairString{
  String first;
  String second;
  public PairString(String f, String s){
    first=f; second=s;
  }
}

class PairInteger{
  Integer first;
  Integer second;
  public PairInteger(Integer f, Integer s){
    first=f; second=s;
  }
}

class PairDouble{
  Double first;
  Double second;
  public PairDouble(Double f, Double s){
    first=f; second=s;
  }
}

// Can hold any type of thing but loses the type information that was
// there and requires casting to use elements of the pair.
class PairObject{
  Object first;
  Object second;
  public PairObject(Object f, Object s){
    first=f; second=s;
  }
}

public class ConcretePairs{
  // Create several kinds of pairs and illustrate problems that arise
  public static void main(String args[]){
    // Series of concrete pairs of Strings, Integers, Doubles
    PairString ps = new PairString("hi","bye");
    String fs = ps.first;
    String ss = ps.second;
    String sumS = fs+ss;

    PairInteger pi = new PairInteger(1,2);
    Integer fi = pi.first;
    Integer si = pi.second;
    Integer sumI = fi+si;


    PairDouble pd = new PairDouble(1.23,2.34);
    Double fd = pd.first;
    Double sd = pd.second;
    Double sumD = fd+sd;

    // On object pair can hold any kind of objects
    PairObject po;
    Object fo, so;

    po = new PairObject("hi","bye");
    fo = po.first;
    so = po.second;
    po = new PairObject(1,2);
    fo = po.first;
    so = po.second;

    // But in order to USE thos objects, casting is required
    Integer i1 = (Integer) po.first;
    Integer i2 = (Integer) po.second;
    Integer sum = i1+i2;

    // Casting happens at runtime which can lead to trouble...
    po = new PairObject("hi","bye");
    i1 = (Integer) po.first;
    i2 = (Integer) po.second;
    sum = i1+i2;
  }
}
