// This version of Coord contains an equals method that means to override
//   public boolean equals(Object other)
// but gets the method prototype wrong. The @Override annotation
// identifies this at compile time and helps to catch this error.
public class Coord {
  public final int row;
  public final int col;

  // Constructor, 
  public Coord(int ir, int ic){
    this.row = ir;
    this.col = ic;
  }

  public String toString(){
    return String.format("(%d,%d)",row,col);
  }
  // // Intended to override, but does it?
  @Override
  public boolean equals(Object other){
    if(other==null || 
       !(other instanceof Coord)){
      return false;
    }
    Coord c = (Coord) other;
    return 
      this.row==c.row &&
      this.col==c.col;
  }

}
