// Dangers of boxed vs unboxed in comparisons
import java.util.ArrayList;

public class TroubleWithRefs{
  public static void demo1(){
    System.out.println("DEMO1");

    int i=1, j=1;
    System.out.println(i==j);  // True of False?

    Integer w=new Integer(i), z=new Integer(j);
    System.out.println(w==z);  // True of False?

    Integer x=i, y=j; 
    System.out.println(x==y);  // True of False?

    System.out.println();
  }

  public static void demo2(){
    System.out.println("DEMO2");
    Integer forty2 = 42;        // silent conversion
    int i = 42;

    ArrayList<Integer> al = new ArrayList<Integer>();
    al.add(new Integer(42));	// proper
    al.add(42);			// silent conversion
    al.add(i);			// silent conversion
    al.add(forty2);		// proper

    // al = [42, 42, 42, 42] - Draw a memory diagram

    int lilI2 = al.get(0);	// Silent conversion
    int lilI3 = al.get(3);	// Silent converstion
    if(lilI2 == lilI3){		// shallow equals
      System.out.println("Hurray!");
    }
    else{
      System.out.println("Huh?");
    }

    Integer bigI2 = al.get(0);	// proper
    Integer bigI3 = al.get(3);	// proper
    if(bigI2 == bigI3){		// shallow equals
      System.out.println("Double hurray!");
    }
    else{
      System.out.println("WTF^M!");
    }      
  }

  public static void main(String args[]){
    demo1();
    demo2();
  }

}
